print "INIT ",pc
	RTL
print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR MainRoutine
	PLB
	RTL


MainRoutine:	LDA $9D
		BNE NoCeiling
		JSL $01801A ;update ypos no gravity
		JSL $018022 ;update xpos no gravity
		JSL $01803A ;interact with mariomnom

		LDA $AA,x
		PHA
		LDA #$FF
		STA $AA,x
		JSL $019138 ;interact with objects I think
		PLA
		STA $AA,x
		LDA $1588,x
		AND #$0F
		BEQ NoCeiling

		STZ $14C8,x ;destroy self
		LDA #$30
		STA $1DFC

		JSR SpawnSmoke


NoCeiling:	JSR Graphics
		RTS

AnimationTable:	db $44,$46,$48,$46

Graphics:	JSL GET_DRAW_INFO
		LDA $00
		STA $0300,y
		LDA $01
		STA $0301,y

		PHX
		LDA $14
		AND #$0F
		LSR A
		LSR A
		TAX
		LDA AnimationTable,x
		STA $0302,y
		PLX

		LDA $64
		ORA $15F6,x
		STA $0303,y

		LDY #$02		;16x16
		LDA #$00		;tile #s
		JSL $01B7B3
		RTS

GET_DRAW_INFO:		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X:		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC #$0040
			CMP #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			PHB
			PHK
			PLB
			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP:		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y:		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			PLB
			RTL

INVALID:		REP #$20
			PLA
			PLY
			PLA
			PHY
			PHA
			SEP #$20
			RTL

SPR_T1:			db $0C,$1C
SPR_T2:			db $01,$02

;===== yer generic SMOKE routine ======

SpawnSmoke:		LDY #$03		; \ find a free slot to display effect
FINDFREE:		LDA $17C0,y		;  |
			BEQ FOUNDONE		;  |
			DEY			;  |
			BPL FINDFREE		;  |
			RTS			; / return if no slots open

FOUNDONE:		LDA #$01		; \ set effect to smoke
			STA $17C0,y		; /

			LDA $D8,x		; \ set y pos of smoke
			STA $17C4,y		; /

			LDA $E4,x		; \ set x pos of smoke
			STA $17C8,y		; /

			LDA #$18		; \ set smoke duration
			STA $17CC,y		; /
			RTS